import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ChatConversation, ChatConversationParam } from './model';


/**
 * 分页查询聊天消息表
 */
export async function pageChatConversation(params: ChatConversationParam) {
  const res = await request.get<ApiResult<PageResult<ChatConversation>>>(
    '/shop/chat-conversation/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询聊天消息表列表
 */
export async function listChatConversation(params?: ChatConversationParam) {
  const res = await request.get<ApiResult<ChatConversation[]>>(
    '/shop/chat-conversation',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加聊天消息表
 */
export async function addChatConversation(data: ChatConversation) {
  const res = await request.post<ApiResult<unknown>>(
    '/shop/chat-conversation',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改聊天消息表
 */
export async function updateChatConversation(data: ChatConversation) {
  const res = await request.put<ApiResult<unknown>>(
    '/shop/chat-conversation',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除聊天消息表
 */
export async function removeChatConversation(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/chat-conversation/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除聊天消息表
 */
export async function removeBatchChatConversation(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/shop/chat-conversation/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询聊天消息表
 */
export async function getChatConversation(id: number) {
  const res = await request.get<ApiResult<ChatConversation>>(
    '/shop/chat-conversation/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
